/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package consumoNFeRoveriSistemas;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * @author thiagolr
 */
public class ConsumoNFeRoveriSistemas {

    /**
     * 
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            //ATENÇÃO!!! Modificar as variáveis token e chave de acesso.

            String token = "AAAAAAAA-AAAA-AAAA-AAAA-AAAAAAAAAAAA";
            String chave = "01234567890123456789012345678901234567890123";

            //Document xmlDoc = getNFeByWebService(token, chave);
            Document xmlDoc = getNFeByHTTP(token, chave);

            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            StringWriter writer = new StringWriter();
            StreamResult streamResult = new StreamResult(writer);
            DOMSource dSource = new DOMSource(xmlDoc);
            transformer.transform(dSource, streamResult);

            String xmlText = writer.toString();
            System.out.println(xmlText);

        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }

    private static Document getNFeByWebService(java.lang.String token, java.lang.String chave) throws UnsupportedEncodingException, SAXException, IOException, Exception {
        roveri.WsRoveriNFeService service = new roveri.WsRoveriNFeService();
        roveri.WsRoveriNFePort port = service.getWsRoveriNFePort();
        String xmlString = port.getNFe(token, chave);

        DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
        documentBuilderFactory.setNamespaceAware(false);
        DocumentBuilder dBuilder = documentBuilderFactory.newDocumentBuilder();

        InputStream stream = new ByteArrayInputStream(xmlString.getBytes("UTF-8"));
        Document doc = dBuilder.parse(stream);

        if (doc.getElementsByTagName("mensagem").getLength() > 0) {
            String mensagem = doc.getElementsByTagName("mensagem").item(0).getNodeValue();
            throw new Exception(mensagem);
        }

        return doc;
    }
    
    

    private static Document getNFeByHTTP(java.lang.String token, java.lang.String chave) throws UnsupportedEncodingException, SAXException, IOException, Exception {
        String USER_AGENT = "Mozilla/5.0";
        String url = "http://www.roveri.inf.br/consultas/nfe.php?token=" + token + "&chave=" + chave;

        URL obj = new URL(url);
        HttpURLConnection con = (HttpURLConnection) obj.openConnection();
       
        //add request header
        con.setRequestProperty("User-Agent", USER_AGENT);

        int responseCode = con.getResponseCode();
        System.out.println("\nSending 'GET' request to URL : " + url);
        System.out.println("Response Code : " + responseCode);

        BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
        String inputLine;
        StringBuffer response = new StringBuffer();

        while ((inputLine = in.readLine()) != null) {
            response.append(inputLine);
        }
        in.close();

        //print result
        String xmlString = response.toString();
        
        DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
        documentBuilderFactory.setNamespaceAware(false);
        DocumentBuilder dBuilder = documentBuilderFactory.newDocumentBuilder();

        InputStream stream = new ByteArrayInputStream(xmlString.getBytes("UTF-8"));
        Document doc = dBuilder.parse(stream);

        if (doc.getElementsByTagName("mensagem").getLength() > 0) {
            String mensagem = doc.getElementsByTagName("mensagem").item(0).getNodeValue();
            throw new Exception(mensagem);
        }

        return doc;
    }

    

}
